VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "ListView with Groups"
   ClientHeight    =   5580
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   7290
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5580
   ScaleWidth      =   7290
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmrDeferMsg 
      Enabled         =   0   'False
      Interval        =   16
      Left            =   3435
      Top             =   3600
   End
   Begin ComctlLib.ListView LVW 
      Height          =   2355
      Left            =   360
      TabIndex        =   0
      Top             =   300
      Width           =   3555
      _ExtentX        =   6271
      _ExtentY        =   4154
      Arrange         =   2
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      Icons           =   "IL"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin ComctlLib.ImageList IL 
      Left            =   3360
      Top             =   2940
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   327682
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const LVM_FIRST As Long = &H1000&
Private Const LVM_SETITEMW As Long = LVM_FIRST + 76&
Private Const LVM_INSERTGROUP As Long = LVM_FIRST + 145&
Private Const LVM_ENABLEGROUPVIEW As Long = LVM_FIRST + 157&

Private Enum LVI_FLAGS
    LVIF_TEXT = &H1&
    LVIF_IMAGE = &H2&
    LVIF_PARAM = &H4&
    LVIF_STATE = &H8&
    LVIF_INDENT = &H10&
    LVIF_NORECOMPUTE = &H800&
    'XP or later:
    LVIF_GROUPID = &H100&
    LVIF_COLUMNS = &H200&
    'Vista or later, though see LVITEM.piColFmt below:
    LVIF_COLFMT = &H10000 'The piColFmt member is valid in addition to puColumns.
End Enum

Private Type LVITEM
    mask As LVI_FLAGS
    iItem As Long
    iSubItem As Long
    state As Long
    stateMask As Long
    pszText As Long
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long
    iGroupId As Long
    cColumns As Long
    puColumns As Long
    'Vista or later:
    piColFmt As Long 'Win7 or later, not implemented in Vista.
    iGroup As Long
End Type

Private Enum LVG_FLAGS
    LVGF_NONE = &H0&
    LVGF_HEADER = &H1&
    LVGF_FOOTER = &H2&
    LVGF_STATE = &H4&
    LVGF_ALIGN = &H8&
    LVGF_GROUPID = &H10&
End Enum

Private Enum LVGSTATE_FLAGS
    LVGS_NORMAL = &H0&
    LVGS_COLLAPSED = &H1&
    LVGS_HIDDEN = &H2&
    LVGS_NOHEADER = &H4&
    LVGS_COLLAPSIBLE = &H8&
    LVGS_FOCUSED = &H10&
    LVGS_SELECTED = &H20&
    LVGS_SUBSETED = &H40&
    LVGS_SUBSETLINKFOCUSED = &H80&
End Enum

Private Enum LVALIGN_FLAGS
    LVGA_HEADER_LEFT = &H1&
    LVGA_HEADER_CENTER = &H2&
    LVGA_HEADER_RIGHT = &H4&
    LVGA_FOOTER_LEFT = &H8&
    LVGA_FOOTER_CENTER = &H10&
    LVGA_FOOTER_RIGHT = &H20&
End Enum

Private Type LVGROUP
    cbSize As Long
    mask As LVG_FLAGS
    pszHeader As Long
    cchHeader As Long
    pszFooter As Long
    cchFooter As Long
    iGroupId As Long
    stateMask As LVGSTATE_FLAGS
    state As LVGSTATE_FLAGS
    uAlign As LVALIGN_FLAGS
End Type

Private Declare Function SendMessage Lib "user32" Alias "SendMessageW" ( _
    ByVal hWnd As Long, _
    ByVal wMsg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long) As Long

Private LVWGroupData As Collection 'Just used in this program for showing group data
                                   'when an item is clicked.
Private Msg As String              'Used to defer MsgBox until we exit the ItemClicked
                                   'handler to avoid "double click" occurring.

Private Function AddGroup( _
    ByVal ListView As ComctlLib.ListView, _
    ByVal GroupId As Long, _
    ByVal Header As String, _
    ByVal Footer As String)
    
    Const INSERT_AT_END As Long = -1
    Dim LVGROUP As LVGROUP
    
    With LVGROUP
        .cbSize = LenB(LVGROUP)
        .mask = LVGF_GROUPID Or LVGF_HEADER Or LVGF_FOOTER Or LVGF_STATE Or LVGF_ALIGN
        .iGroupId = GroupId
        .pszHeader = StrPtr(Header)
        .pszFooter = StrPtr(Footer)
        .stateMask = LVGS_COLLAPSIBLE
        .state = LVGS_COLLAPSIBLE
        'We'll align the header left and the footer centered:
        .uAlign = LVGA_HEADER_LEFT Or LVGA_FOOTER_CENTER
    End With
    If SendMessage(ListView.hWnd, LVM_INSERTGROUP, INSERT_AT_END, VarPtr(LVGROUP)) < 0 Then
        Err.Raise &H80046100, Me.Name, "LVM_INSERTGROUP failed"
    End If
End Function

Private Sub AddItemToGroup( _
    ByVal ListView As ComctlLib.ListView, _
    ByVal Item As Long, _
    ByVal GroupId As Long)
    'Item is a base-1 item index.
    Dim LVITEM As LVITEM
    
    With LVITEM
        .mask = LVIF_GROUPID
        .iItem = Item - 1 'Correct to base-0 index for this usage.
        .iGroupId = GroupId
    End With
    If SendMessage(ListView.hWnd, LVM_SETITEMW, 0, VarPtr(LVITEM)) = 0 Then
        Err.Raise &H80046108, Me.Name, "LVM_SETITEM failed"
    End If
End Sub

Private Function GenText(ByVal MinWidth As Long, ByVal MaxWidth As Long) As String
    Dim Length As Long
    Dim Value As String
    Dim I As Long
    
    Length = MinWidth + Int(Rnd() * (MaxWidth - MinWidth + 1))
    Value = Space$(Length)
    For I = 1 To Length
        Mid$(Value, I, 1) = ChrW$(&H60& + Int(Rnd() * 27)) 'Chars "`" through "z".
    Next
    GenText = StrConv(Trim$(Replace$(Value, "`", " ")), vbProperCase)
End Function

Private Sub Form_Load()
    Dim Keys As Variant
    Dim I As Long
    Dim GroupData As Variant
    Dim IconIndex As Long
    Dim FirstItemInTopGroup As Long 'Index of the first item in the topmost group.
    
    If SendMessage(LVW.hWnd, LVM_ENABLEGROUPVIEW, True, 0) <> 1 Then
        MsgBox "Requires Common Controls 6.0 or later", vbOKOnly Or vbCritical
        Unload Me
        Exit Sub
    End If

    Icon = LoadResPicture("AppIcon", vbResIcon) 'To avoid "crab" becoming the
                                                'EXE icon we can't rely on a
                                                'design-time Form icon.

    'To safely use 256-color icons in a ComctlLib.ImageList (i.e. without
    'color distortion) we can't rely on including them at design-time
    'because VB6 doesn't persist them into the .FRX properly.  So we'll
    'build it now from resources:
    Keys = Array("Crab", "Dolphin", "Duck", "Fish")
    With IL
        .ImageHeight = 32
        .ImageWidth = 32
        With .ListImages
            For I = 0 To UBound(Keys)
                .Add , Keys(I), LoadResPicture(Keys(I), vbResIcon)
            Next
        End With
    End With

    'Can't add groups to an empty ListView.  MSDN article "LVM_INSERTGROUP message"
    'says:
    '
    '   "A group cannot be inserted into an empty list-view control."
    '
    'Oddly it seems to work for Vista though, which means group creation below can
    'be moved before this and we could then call AddItemToGroup() within the loop
    'here.
    '
    'But add our items now.  Groups are listed by index, so in our case this means
    'the first group we created is the topmost one.  Snag FirstItemInTopGroup
    'as we go:
    With LVW
        .View = lvwIcon
        .Arrange = lvwAutoTop 'Required when using groups.
        With .ListItems
            For I = 1 To 60
                IconIndex = Int(Rnd() * 4) + 1
                If FirstItemInTopGroup = 0 And IconIndex = 1 Then FirstItemInTopGroup = I
                .Add , , GenText(3, 10), IconIndex
            Next
        End With
    End With

    'Create groups, capturing their data for later use.  We are using the "image
    'type" as our "grouping" attribute in this program:
    Set LVWGroupData = New Collection
    With IL.ListImages
        For I = 1 To .Count
            GroupData = Array(I, .Item(I).Key, GenText(3, 14) & " " & GenText(3, 14))
            AddGroup LVW, GroupData(0), GroupData(1), GroupData(2)
            LVWGroupData.Add GroupData
        Next
    End With
    
    'Add items to their groups, finish by scrolling to top:
    With LVW.ListItems
        For I = 1 To .Count
            AddItemToGroup LVW, I, .Item(I).Icon
        Next
        If FirstItemInTopGroup > 0 Then
            'This is done to scroll the ListView so the "first" item is at the
            'top, i.e. scroll to top.
            With .Item(FirstItemInTopGroup)
                '.EnsureVisible doesn't seem to work with groups enabled:
                .Selected = True
                .Selected = False
            End With
        End If
    End With
End Sub

Private Sub Form_Resize()
    If WindowState <> vbMinimized Then
        LVW.Move 0, 0, ScaleWidth, ScaleHeight
    End If
End Sub

Private Sub LVW_ItemClick(ByVal Item As ComctlLib.ListItem)
    Dim GroupData As Variant
    
    'We've used the icon as the GroupId to place this item into so
    'we can grab that here to index LVWGroupData:
    GroupData = LVWGroupData.Item(Item.Icon)
    Msg = "Group: " & CStr(GroupData(0)) _
        & ", Header: " & GroupData(1) _
        & ", Footer: " & GroupData(2) & vbNewLine _
        & "Item: " & CStr(Item.Index) _
        & ", Text: " & Item.Text
    tmrDeferMsg.Enabled = True 'Defer MsgBox.
End Sub

Private Sub tmrDeferMsg_Timer()
    tmrDeferMsg.Enabled = False
    MsgBox Msg, vbOKOnly, "Item clicked"
End Sub
